//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "cifernik.h"
#include "voda.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tcifernik1 *cifernik1;
//---------------------------------------------------------------------------
__fastcall Tcifernik1::Tcifernik1(TComponent* Owner)
   : TForm(Owner), deltah(M_PI/6), deltam(M_PI/30)
{
   unsigned short ms;
   DecodeTime(Time(), h, m, s, ms);
}
//---------------------------------------------------------------------------

inline int min(int a, int b) { return a < b ? a : b; }

void Tcifernik1::Znacky()
{
  Canvas -> Pen -> Color = clYellow;
  Canvas -> Brush -> Color = clYellow;

  double fi = 0;                        // Poten hel
  for(int i = 0; i < 12; i++)           // Znaky hodin
  {
   int x = XS + R * cos(fi);
   int y = YS + R * sin(fi);
   Canvas -> Ellipse(x-r, y-r, x+r, y+r);
   fi += deltah;
  }
}

void Tcifernik1::PomaleRucicky(unsigned short hod, unsigned short min)
{
  Canvas -> Pen -> Width = 4;
  Canvas -> Pen -> Color = clYellow;
  TPenMode pmStare =  Canvas -> Pen -> Mode;
  Canvas -> Pen -> Mode = pmXor;

  // Hodinov ruka
  double fi = deltah * (hod + min/60.0);
  Canvas -> MoveTo(XS, YS);
  Canvas -> LineTo(XS + 0.75*R*sin(fi), YS - 0.75*R*cos(fi));

  // Minutov ruka
  Canvas -> Pen -> Width = 2;
  fi = deltam * min;
  Canvas -> MoveTo(XS, YS);
  Canvas -> LineTo(XS + R*sin(fi), YS - R*cos(fi));
  Canvas -> Pen -> Mode = pmStare;
}

void Tcifernik1::Vterinovka(unsigned short sec)
{
  // Vteinov ruka
  Canvas -> Pen -> Width = 1;
  Canvas -> Pen -> Color = clWhite;
  TPenMode pmStare =  Canvas -> Pen -> Mode;
  Canvas -> Pen -> Mode = pmXor;
  double fi = deltam * sec;
  Canvas -> MoveTo(XS, YS);
  Canvas -> LineTo(XS + R*sin(fi), YS - R*cos(fi));
  Canvas -> Pen -> Mode = pmStare;
}

void __fastcall Tcifernik1::FormResize(TObject *Sender)
{
    // Sted a polomr cifernku, polomr znaek
    XS =ClientWidth /2;
    YS = ClientHeight / 2;
    R = min (XS, YS)-10;
    r = R/50+1;
    Repaint();
}
//---------------------------------------------------------------------------
void __fastcall Tcifernik1::nepokojTimer(TObject *Sender)
{
   unsigned short ms; // Pomocn promnn
   unsigned short Hnove, Mnove, Snove;
   DecodeTime(Time(), Hnove, Mnove, Snove, ms);
   Vterinovka(s);
   Vterinovka(Snove);
   s = Snove;
   if(m != Mnove)
   {
        PomaleRucicky(h, m);
        PomaleRucicky(Hnove, Mnove);
        h = Hnove; m = Mnove;
   }
   Caption = AnsiString(h)+":"+AnsiString(m)+":"+s;
}
//---------------------------------------------------------------------------


void __fastcall Tcifernik1::FormPaint(TObject *Sender)
{
   Znacky();
   PomaleRucicky(h, m);
   Vterinovka(s);
   Caption = AnsiString(h)+":"+AnsiString(m)+":"+s;
}
//---------------------------------------------------------------------------


void __fastcall Tcifernik1::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if(Button == mbRight && Shift.Contains(ssAlt))
    {
      vodotrysk -> ClientHeight = 100;
      vodotrysk -> ClientWidth = 100;
      vodotrysk->Left = cifernik1->Left + (cifernik1->Width - vodotrysk->Width)/2;
      vodotrysk->Top = cifernik1->Top - vodotrysk->Height;
      vodotrysk -> Visible = true;
      vodotrysk -> animator -> Enabled = true;
    }
}
//---------------------------------------------------------------------------

