//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "hlavni.h"
#include "detske.h"
#include "oprog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THlavniOkno *HlavniOkno;
//---------------------------------------------------------------------------
__fastcall THlavniOkno::THlavniOkno(TComponent* Owner)
    : TForm(Owner), kolik(0)
{
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::mn_konecClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::mn_otevriClick(TObject *Sender)
{
    AnsiString jmeno;
    TDetskeOkno *DO;
    if(dlg_otevri -> Execute())
    {
        try
        {
           jmeno = dlg_otevri -> FileName;
           DO = new TDetskeOkno(this);
           DO -> Show();
           DO -> Caption = ExtractFileName(jmeno);
           DO -> nastavJmeno(jmeno);
           DO -> obrazek -> Picture ->  LoadFromFile(jmeno);
           NastavPosuvniky();
        }
        catch(Exception &e)
        {
          Application -> MessageBox (("Nepodailo se otevt obrzek " + jmeno).c_str(),
                                      "Chyba", MB_OK);
          DO -> Close();
        }
    }
}
//---------------------------------------------------------------------------
void THlavniOkno::ZrusOkno()
{
 if(!--kolik)
 {
    mn_okno->Visible = false;
    tl_scroll -> Enabled = false;
    tl_stretch -> Enabled = false;
    tl_zavri -> Enabled = false;
    tl_ulozjako -> Enabled = false;
    tl_zavrivse -> Enabled = false;
 }
}
void THlavniOkno::PridejOkno()
{
 if(++kolik == 1)
 {
    mn_okno->Visible = true;
    tl_scroll -> Enabled = true;
    tl_stretch -> Enabled = true;
    tl_zavri -> Enabled = true;
    tl_ulozjako -> Enabled = true;
    tl_zavrivse -> Enabled = true;
 }
}
void __fastcall THlavniOkno::tl_zavriClick(TObject *Sender)
{
    ActiveMDIChild -> Close();
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::tl_scrollClick(TObject *Sender)
{
    NastavPosuvniky();    
}
//---------------------------------------------------------------------------
void THlavniOkno::NastavPosuvniky()
{
   TDetskeOkno *DO = dynamic_cast<TDetskeOkno*>(ActiveMDIChild);
   if(DO)
   {
     DO -> obrazek -> Stretch = false;
     DO -> AutoScroll = true;
     DO -> HorzScrollBar -> Range = DO -> obrazek -> Picture -> Bitmap -> Width;
     DO -> VertScrollBar -> Range = DO -> obrazek -> Picture -> Bitmap -> Height;
   }
}

void THlavniOkno::NastavPrizpusobeni()
{
   TDetskeOkno *DO = dynamic_cast<TDetskeOkno*>(ActiveMDIChild);
   if(DO)
   {
     DO -> obrazek -> Stretch = true;
     DO -> AutoScroll = false;
     DO -> HorzScrollBar -> Range = 0;
     DO -> VertScrollBar -> Range = 0;
   }
}
void __fastcall THlavniOkno::tl_stretchClick(TObject *Sender)
{
    NastavPrizpusobeni();    
}
//---------------------------------------------------------------------------


void __fastcall THlavniOkno::mn_oprogramuClick(TObject *Sender)
{
    OknoOProgramu -> ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_dlazdiceClick(TObject *Sender)
{
    Tile();    
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_kaskadaClick(TObject *Sender)
{
    Cascade();    
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_usporadejikonyClick(TObject *Sender)
{
    ArrangeIcons();
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::tl_ulozjakoClick(TObject *Sender)
{
    TDetskeOkno *DO = dynamic_cast<TDetskeOkno*>(ActiveMDIChild);
    if(DO)
    {
        AnsiString jmeno = DO -> vratJmeno();
        dlg_ulozjako -> Title = "Ulo " + ExtractFileName(jmeno) + " jako...";
        dlg_ulozjako -> FileName = jmeno;
        if(dlg_ulozjako -> Execute())
        {
            jmeno = dlg_ulozjako -> FileName;
            if(FileExists(jmeno) && Application -> MessageBox(
               (jmeno + "existuje.\nPepsat?").c_str(),
               "Dotaz", MB_YESNO | MB_ICONQUESTION))
                    return;
            DO->obrazek->Picture->SaveToFile(jmeno);
            DO->Caption = ExtractFileName(jmeno);
            DO->nastavJmeno(jmeno);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::tl_zavrivseClick(TObject *Sender)
{
    for(int i = 0; i < MDIChildCount; i++)
    MDIChildren[i] -> Close();    
}
//---------------------------------------------------------------------------

