//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Vypoc.h"
#include "okno1.h"
#include "init.h"
#include "nastav.h"
#include "oprog.h"
#include "THVYPOC.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THlavniOkno *HlavniOkno;
//---------------------------------------------------------------------------
__fastcall THlavniOkno::THlavniOkno(TComponent* Owner)
    : TForm(Owner), pocetIteraci(InitPocetIteraci),
    XLH(InitXLH), YLH(InitYLH), XPD(InitXPD), YPD(InitYPD),
    sirka(InitSirka), vyska(InitVyska), ulozeno(true),
    barva_mnoziny(InitBMno), barva_okoli(InitBPoz),
    dole(false), obdelnik(false), vyp(0)
{
   Nastaveni();
}
//---------------------------------------------------------------------------
void THlavniOkno::NastavPosuvniky()
{
 AutoScroll = true;
 HorzScrollBar->Range = sirka;
 VertScrollBar->Range = vyska;
}

void __fastcall THlavniOkno::mn_konecClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::mn_nastaveniClick(TObject *Sender)
{
    if(dlg_nastaveni->ShowModal()==IDOK)
    {
      XLH = dlg_nastaveni -> ed_xlh -> Text.ToDouble();
      XPD = dlg_nastaveni -> ed_xpd -> Text.ToDouble();
      YLH = dlg_nastaveni -> ed_ylh -> Text.ToDouble();
      YPD = dlg_nastaveni -> ed_ypd -> Text.ToDouble();
      VypoctiKonstanty();
      pocetIteraci = dlg_nastaveni -> ed_pocit -> Text.ToInt();
      sirka = dlg_nastaveni -> ed_sirka -> Text.ToInt();
      vyska = dlg_nastaveni -> ed_vyska -> Text.ToInt();
      NastavPosuvniky();
      mn_novyClick(Sender);
      if(dlg_nastaveni->rb_cc->Checked)
      {
       barva_mnoziny = InitBMno;
       barva_okoli = InitBPoz;
      }
      else
      {
       barva_mnoziny = BMno2;
       barva_okoli = BPoz2;
      }
    }
}
//---------------------------------------------------------------------------

void THlavniOkno::VypoctiKonstanty()
{
 ax = (XPD-XLH)/sirka;
 ay = (YPD-YLH)/vyska;
}

void __fastcall THlavniOkno::mn_vypocetClick(TObject *Sender)
{
    ulozeno = false; // Obrzek jet nebyl uloen
    mn_prerus ->Enabled = true;
    mn_ukonci ->Enabled = true;
    mn_vypocet->Enabled = false;
    mn_novy->Enabled = false;
    mn_uloz->Enabled = false;
    vyp = new TVypocet(false);
}
//---------------------------------------------------------------------------



void __fastcall THlavniOkno::mn_ulozClick(TObject *Sender)
{
    static int pocitadlo = 0;
    AnsiString jmeno = AnsiString("Obr") + AnsiString(pocitadlo++) + ".bmp";
    dlg_ulozjako -> FileName = jmeno;
    dlg_ulozjako -> DefaultExt = "bmp";
    if(dlg_ulozjako -> Execute())
    {
       jmeno = dlg_ulozjako -> FileName;
       im_obr -> Picture -> SaveToFile(jmeno);
       ulozeno = true;
       sb_stav->SimpleText = "Uloeno";
    }
}
//---------------------------------------------------------------------------


int THlavniOkno::DotazChcesUlozit()
{
 return
 Application -> MessageBox("Obrzek nebyl uloen.\nChcete ho uloit?", " Upozornn", MB_YESNOCANCEL);
}

void __fastcall THlavniOkno::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
    if(!ulozeno)
    {
      switch(DotazChcesUlozit())
      {
       case IDYES:
        mn_ulozClick(Sender);
        CanClose = ulozeno;
        break;
       case IDNO:
        CanClose = true;
        break;
       case IDCANCEL:
        CanClose = false;
        break;
      }
    }
    else CanClose = true;
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_novyClick(TObject *Sender)
{
    if(!ulozeno)
    {
      switch(DotazChcesUlozit())
      {
        case IDYES:
          mn_ulozClick(Sender);
          break;
        case IDNO:
          break;
        case IDCANCEL:
          return;
      }
    }
    Nastaveni();
    im_obr->Canvas->FillRect(ClientRect);
    ulozeno = true;
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_oprogramuClick(TObject *Sender)
{
    Oprogramu->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_prerusClick(TObject *Sender)
{
   if(vyp->Suspended)
   {
    mn_prerus -> Caption = "Peru";
    vyp->Resume();
   }
   else
   {
    vyp->Suspend();
    mn_prerus -> Caption = "Pokrauj";
    sb_stav->SimpleText = "Perueno";
   }
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::im_obrMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(Button == mbLeft)
   {
      dole = true;
      xlhv = X;
      ylhv = Y;
   }
}
//---------------------------------------------------------------------------

void THlavniOkno::NakresliObdelnik()
{
  TCanvas* C = im_obr -> Canvas;  // Pomocn promnn pro zjednoduen zpisu
  C -> Pen -> Color = clRed;      // Barva ry
  TPenMode pm = C -> Pen -> Mode;  // Zapamatuj si mod a styp pera a styp ttce
  TPenStyle ps = C -> Pen -> Style;
  TBrushStyle bs = C -> Brush -> Style;
  C -> Pen -> Mode = pmXor;        // Reim XOR
  C -> Pen -> Style = psDot;       // rkovan ra
  C -> Brush -> Style = bsClear;   // Nevyplovat obdlnk
  C -> Rectangle(xlhv, ylhv, xpdv, ypdv);   // Nakresli obdlnk
  C -> Pen -> Mode = pm;   // Obnov zapamatovan hodnoty
  C -> Pen -> Style = ps;
  C -> Brush -> Style = bs;
}

void __fastcall THlavniOkno::im_obrMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if(dole)
    {
      if(obdelnik)
         NakresliObdelnik();
      obdelnik = true;
      xpdv = X;
      ypdv = Y;
      NakresliObdelnik();
    }
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::im_obrMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if(obdelnik)
    {
      dole = false;
      NakresliObdelnik();
      mn_nastaveniClick(Sender);
      obdelnik = false;
    }
}
//---------------------------------------------------------------------------



void __fastcall THlavniOkno::mn_ukonciClick(TObject *Sender)
{
    if(vyp->Suspended)
    {
     vyp->Resume();
     mn_prerus->Caption = "Peru";
    }
    vyp->Terminate();
}
//---------------------------------------------------------------------------


void THlavniOkno::Nastaveni()
{
    //TODO: Add your source code here
    im_obr -> Picture -> Bitmap -> Height = vyska;
    im_obr -> Picture -> Bitmap -> Width = sirka;
    NastavPosuvniky();
    VypoctiKonstanty();
}

