//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "okno1.h"
#include "init.h"
#include "nastav.h"
#include "Vypoc.h"
#include "oprog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THlavniOkno *HlavniOkno;
//---------------------------------------------------------------------------
__fastcall THlavniOkno::THlavniOkno(TComponent* Owner)
    : TForm(Owner), pocetIteraci(InitPocetIteraci),
    XLH(InitXLH), YLH(InitYLH), XPD(InitXPD), YPD(InitYPD),
    sirka(im_obr->Width), vyska(im_obr->Height), ulozeno(true)
{
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::mn_konecClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::mn_nastaveniClick(TObject *Sender)
{
    if(dlg_nastaveni->ShowModal()==IDOK)
    {
      XLH = dlg_nastaveni -> ed_xlh -> Text.ToDouble();
      XPD = dlg_nastaveni -> ed_xpd -> Text.ToDouble();
      YLH = dlg_nastaveni -> ed_ylh -> Text.ToDouble();
      YPD = dlg_nastaveni -> ed_ypd -> Text.ToDouble();
      VypoctiKonstanty();
      pocetIteraci = dlg_nastaveni -> ed_pocit -> Text.ToInt();
    }
}
//---------------------------------------------------------------------------

void THlavniOkno::VypoctiKonstanty()
{
 ax = (XPD-XLH)/sirka;
 ay = (YPD-YLH)/vyska;
}

void __fastcall THlavniOkno::mn_vypocetClick(TObject *Sender)
{
    ulozeno = false; // Obrzek jet nebyl uloen
    for(int ix = 0; ix < sirka; ix++)
    {
      for(int iy = 0; iy < vyska; iy++)
       im_obr -> Canvas -> Pixels[ix][iy] = Vypocet(X(ix), Y(iy), pocetIteraci);
    }
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::FormCreate(TObject *Sender)
{
    im_obr -> Picture -> Bitmap -> Height = vyska;
    im_obr -> Picture -> Bitmap -> Width = sirka;
    VypoctiKonstanty();
}
//---------------------------------------------------------------------------


void __fastcall THlavniOkno::mn_ulozClick(TObject *Sender)
{
    static int pocitadlo = 0;
    AnsiString jmeno = AnsiString("Obr") + AnsiString(pocitadlo++) + ".bmp";
    dlg_ulozjako -> FileName = jmeno;
    dlg_ulozjako -> DefaultExt = "bmp";
    if(dlg_ulozjako -> Execute())
    {
       jmeno = dlg_ulozjako -> FileName;
       im_obr -> Picture -> SaveToFile(jmeno);
       ulozeno = true;
    }
}
//---------------------------------------------------------------------------


int THlavniOkno::DotazChcesUlozit()
{
 return
 Application -> MessageBox("Obrzek nebyl uloen.\nChcete ho uloit?", " Upozornn", MB_YESNOCANCEL);
}

void __fastcall THlavniOkno::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
    if(!ulozeno)
    {
      switch(DotazChcesUlozit())
      {
       case IDYES:
        mn_ulozClick(Sender);
        CanClose = ulozeno;
        break;
       case IDNO:
        CanClose = true;
        break;
       case IDCANCEL:;
        CanClose = false;
        break;
      }
    }
    else CanClose = true;
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_novyClick(TObject *Sender)
{
    if(!ulozeno)
    {
      switch(DotazChcesUlozit())
      {
        case IDYES:
          mn_ulozClick(Sender);
          break;
        case IDNO:
          break;
        case IDCANCEL:
          return;
      }
    }
    sirka = im_obr->Width;
    vyska = im_obr->Height;
    FormCreate(Sender);
    im_obr->Canvas->FillRect(ClientRect);
    ulozeno = true;
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_oprogramuClick(TObject *Sender)
{
    Oprogramu->ShowModal();
}
//---------------------------------------------------------------------------

