//---------------------------------------------------------------------------
#ifndef okno1H
#define okno1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include "thvypoc.h"
//---------------------------------------------------------------------------
class THlavniOkno : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *HlavniMenu;
    TSavePictureDialog *dlg_ulozjako;
    TMenuItem *mn_soubor;
    TMenuItem *mn_uloz;
    TMenuItem *mn_novy;
    TMenuItem *N1;
    TMenuItem *mn_konec;
    TMenuItem *mn_obrazek;
    TMenuItem *mn_nastaveni;
    TMenuItem *N2;
    TMenuItem *mn_vypocet;
    TMenuItem *mn_napoveda;
    TMenuItem *mn_oprogramu;
    TPanel *pa_obr;
    TImage *im_obr;
    TMenuItem *mn_prerus;
    TStatusBar *sb_stav;
    TMenuItem *mn_ukonci;
    void __fastcall mn_konecClick(TObject *Sender);
    void __fastcall mn_nastaveniClick(TObject *Sender);
    
    void __fastcall mn_vypocetClick(TObject *Sender);
    
    void __fastcall mn_ulozClick(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall mn_novyClick(TObject *Sender);
    void __fastcall mn_oprogramuClick(TObject *Sender);
    void __fastcall mn_prerusClick(TObject *Sender);
    void __fastcall im_obrMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall im_obrMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall im_obrMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    
    
    void __fastcall mn_ukonciClick(TObject *Sender);
private:	// User declarations
    TVypocet* vyp;
    int pocetIteraci;
    double XLH, YLH, XPD, YPD;  // Souadnice LH a PD rohu (v rovin X-Y)
    int sirka, vyska;// Rozmry bitov mapy v pixelech
    double ax, ay;  // Konstanty pro pepocet souadnic na pixely
    bool ulozeno;// Byl u obrzek uloen?
    TColor barva_mnoziny, barva_okoli;
    bool dole;                  // Je stisknuta my?
    bool obdelnik;
    bool preruseno;
    AnsiString jmenoDLL;
    int xlhv, ylhv, xpdv, ypdv; // Vybran obdlnk
    void VypoctiKonstanty();
    int DotazChcesUlozit();
    void NastavPosuvniky();
    void NakresliObdelnik();
public:		// User declarations
    __fastcall THlavniOkno(TComponent* Owner);
    int PocetIteraci() {return pocetIteraci;}
    int Sirka() { return sirka; }      // Pstupov procedury
    int Vyska() { return vyska; }
    int krok; // Krok zobrazovn
    double xlh() { return XLH; }
    double xpd() { return XPD; }
    double ylh() { return YLH; }
    double ypd() { return YPD; }
    double X(int x) { return ax*x+XLH; }
    double Y(int y) { return ay*y+YLH; }
    bool Obdelnik() { return obdelnik;}
    int Krok() { return krok; }
    int Xlhv() { return xlhv; }
    int Xpdv() { return xpdv; }
    int Ylhv() { return ylhv; }
    int Ypdv() { return ypdv; }
    double Ax() { return ax; }
    double Ay() { return ay; }
    TColor bmnoziny() { return barva_mnoziny;}
    TColor bokoli() { return barva_okoli;}
    AnsiString JmenoDLL() { return jmenoDLL; }
    void Nastaveni();
};
//---------------------------------------------------------------------------
extern PACKAGE THlavniOkno *HlavniOkno;
//---------------------------------------------------------------------------
#endif
