//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "okno1.h"
#include "THVYPOC.h"
#include "vypoc.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TVypocet::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall TVypocet::TVypocet(bool CreateSuspended)
    : TThread(CreateSuspended), barva_mnoziny(HlavniOkno->bmnoziny()), barva_okoli(HlavniOkno->bokoli()),
    XLH(HlavniOkno->xlh()), YLH(HlavniOkno->ylh()), XPD(HlavniOkno->xpd()), YPD(HlavniOkno->ypd()),
    sirka(HlavniOkno->Sirka()), vyska(HlavniOkno->Vyska()), ax(HlavniOkno->Ax()), ay(HlavniOkno->Ay()),
    C(HlavniOkno->im_obr->Canvas), pocetIteraci(HlavniOkno->PocetIteraci())
{
    Priority = tpNormal;
    FreeOnTerminate = true;
    OnTerminate = &Konec;
}
//---------------------------------------------------------------------------
void __fastcall TVypocet::Execute()
{
    //---- Place thread code here ----
    for(int ix = 0; ix < sirka; ix++)
    {
     for(int iy = 0; iy < vyska && ! Terminated; iy++)
     {
        TColor barva = Vypocet(X(ix), Y(iy), pocetIteraci, barva_mnoziny, barva_okoli);
        C->Lock();
        C -> Pixels[ix][iy] = barva;
        C-> Unlock();
     }
     TextStavoveRadky = AnsiString(100*ix/sirka)+"%";
     Synchronize(NastavStavovouRadku);
    }
}
//---------------------------------------------------------------------------
void __fastcall TVypocet::Konec(TObject* Sender)
{
   HlavniOkno->sb_stav->SimpleText = "Hotovo";
   HlavniOkno->mn_prerus ->Enabled = false;
   HlavniOkno->mn_vypocet->Enabled = true;
   HlavniOkno->mn_novy->Enabled = true;
   HlavniOkno->mn_uloz->Enabled = true;
   HlavniOkno->mn_ukonci ->Enabled = false;
}

void __fastcall TVypocet::NastavStavovouRadku()
{
    //TODO: Add your source code here
    HlavniOkno->sb_stav->SimpleText = TextStavoveRadky;
}

