//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "okno1.h"
#include "THVYPOC.h"
#include "vypocet.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TVypocet::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall TVypocet::TVypocet(bool CreateSuspended)
    : TThread(CreateSuspended), barva_mnoziny(HlavniOkno->bmnoziny()), barva_okoli(HlavniOkno->bokoli()),
    XLH(HlavniOkno->xlh()), YLH(HlavniOkno->ylh()), XPD(HlavniOkno->xpd()), YPD(HlavniOkno->ypd()),
    sirka(HlavniOkno->Sirka()), vyska(HlavniOkno->Vyska()), ax(HlavniOkno->Ax()), ay(HlavniOkno->Ay()),
    pocetIteraci(HlavniOkno->PocetIteraci()), krok(HlavniOkno->Krok())
{
    Priority = tpNormal;
    FreeOnTerminate = true;
    OnTerminate = &Konec;
}
//---------------------------------------------------------------------------
void __fastcall TVypocet::Execute()
{
    //---- Place thread code here ----
    bmp = new Graphics::TBitmap;
    bmp -> Height = vyska;
    bmp -> Width = sirka;
    for(int ix = 0; ix < sirka; ix++)
    {
     for(int iy = 0; iy < vyska && ! Terminated; iy++)
     {
        bmp -> Canvas -> Pixels[ix][iy] = Vypocet(X(ix), Y(iy), pocetIteraci, barva_mnoziny, barva_okoli);
     }
     TextStavoveRadky = AnsiString(100*ix/sirka)+"%";
     Synchronize(NastavStavovouRadku);
     if(!(ix% krok))
     {
       Synchronize(Zobraz);
     }
    }
    Synchronize(Zobraz);     // Dokresli zbytek
    delete bmp;
}
//---------------------------------------------------------------------------
void __fastcall TVypocet::Konec(TObject* Sender)
{
   HlavniOkno->sb_stav->SimpleText = "Hotovo";
   HlavniOkno->mn_prerus ->Enabled = false;
   HlavniOkno->mn_vypocet->Enabled = true;
   HlavniOkno->mn_novy->Enabled = true;
   HlavniOkno->mn_uloz->Enabled = true;
   HlavniOkno->mn_ukonci ->Enabled = false;
}

void __fastcall TVypocet::NastavStavovouRadku()
{
   HlavniOkno->sb_stav->SimpleText = TextStavoveRadky;
}

void __fastcall TVypocet::Zobraz()
{
  HlavniOkno -> im_obr -> Picture -> Bitmap -> Canvas -> Draw(0,0, bmp);
}
